version: "3"
services:
   rabbit:
    image: pivotalrabbitmq/rabbitmq-autocluster
    tty: true
    command:  sh -c "sleep 20; rabbitmq-server;" 
    environment:
      - TCP_PORTS=15672, 5672
      - AUTOCLUSTER_TYPE=consul
      - AUTOCLUSTER_DELAY=60
      - CONSUL_HOST=consul
      - CONSUL_SVC_ADDR_AUTO=true
      - AUTOCLUSTER_CLEANUP=true
      - CLEANUP_WARN_ONLY=false
      - CONSUL_DEREGISTER_AFTER=60 
    ports:
      - 15672:15672
      - 5672:5672
      - 5671:5671
      - 15671:15671
    networks:
      - back
    deploy:
      replicas: 2
      restart_policy:
        condition: on-failure
        delay: 5s
        max_attempts: 3
        window: 120s

    
   haproxy:
    image: dockercloud/haproxy
    environment:
      - MODE=tcp
#    volumes:
#      - /var/run/docker.sock:/var/run/docker.sock
    networks:
      - back
    deploy:
      replicas: 1
      restart_policy:
        condition: on-failure
        delay: 5s
        max_attempts: 3
        window: 120s
    ports:
      - 80:80

   consul:
    image: "consul"
    hostname: "consul"
    networks:
      - back
    deploy:
      replicas: 1
      restart_policy:
        condition: on-failure
        delay: 5s
        max_attempts: 3
        window: 120s
    ports:
      - 8400:8400
      - 8300:8300
      - 8600:8600
      - 8301:8301
      - 8501:8501

networks:
  back:
